<script setup lang="ts">
import { ref, onMounted } from 'vue'
import { useI18n } from 'vue-i18n'
import { MessageBoxType, type MessageBoxOptions } from '../components/MessageBox'
import MessageBox from '../components/MessageBox.vue'
import { type WaitBoxOptions } from '../components/WaitBox'
import WaitBox from '../components/WaitBox.vue'

// using
const { t } = useI18n({
	messages: {
		en: {
			title: `Test Boxes`,
			generic: `MessageBox`,
			close: `Close`,
			ok: `OK`,
			okCancel: `OK/Cancel`,
			yesNo: `Yes/No`,
			retryCancel: `Retry/Cancel`,
			simple: `MessageBox with Presets`,
			info: `Infomation`,
			warning: `Warning`,
			error: `Error`,
			question: `Question`,
			content: `Aaaa Bbbb Cccc Dddd\nใช่ใช่ใช่ใช่ ไม่ไม่ไม่ไม่\nYes Yes Yes Yes!`,
			wait: `Waiting...`,
		},
		th: {
			title: `ทดสอบกล่อง`,
			generic: `กล่องข้อความ`,
			close: `ปิด`,
			ok: `ตกลง`,
			okCancel: `ตกลง/ยกเลิก`,
			yesNo: `ใช่/ไม่ใช่`,
			retryCancel: `ลองใหม่/ยกเลิก`,
			simple: `กล่องข้อความ พร้อมเซ็ตค่าเรียบร้อย`,
			info: `ข่าวสาร`,
			warning: `แจ้งเตือน`,
			error: `เกิดข้อผิดพลาด`,
			question: `คำถาม`,
			content: `ใช่ใช่ใช่ใช่ ไม่ไม่ไม่ไม่\nAaaa Bbbb Cccc Dddd\nใช่ ใช่ ใช่ ใช่!`,
			wait: `กรุณารอ...`,
		},
	},
})

// states
const messageBox = ref(<InstanceType<typeof MessageBox> | null>null)
const waitBox = ref(<InstanceType<typeof WaitBox> | null>null)

onMounted(() => {
	messageBox.value?.setDefaults(<MessageBoxOptions>{
		barrierBackground: '#116c',
		titleBackground: '#369',
		titleColor: '#eef',
		rightIcon: true,
	})

	waitBox.value?.setDefaults(<WaitBoxOptions>{
		barrierBackground: '#339c',
		edgeBackground: '#393',
		iconColor: '#c33',
		rightIcon: true,
	})
})

// ----------------------------------------------------------------------

function closed(result: boolean): void {
	console.log(`[callback] message box closed, result: ${result}`)
}

function open(caption: string, type: MessageBoxType, alternateFocus: boolean, barrierDismissible: boolean): void {
	const box = messageBox.value!
	if (!box.isOpen()) {
		box.open({
			caption,
			content: t('content'),
			type,
			alternateFocus,
			barrierDismissible,
			callback: closed,
		})
	}
}

function info(): void {
	const box = messageBox.value!
	if (!box.isOpen()) {
		box.info(t('content'), closed)
	}
}

function warning(): void {
	const box = messageBox.value!
	if (!box.isOpen()) {
		box.warning(t('content'), closed)
	}
}

function error(): void {
	const box = messageBox.value!
	if (!box.isOpen()) {
		box.error(t('content'), closed)
	}
}

function question(): void {
	const box = messageBox.value!
	if (!box.isOpen()) {
		box.question(t('content'), closed)
	}
}

function wait(): void {
	const box = waitBox.value!
	if (!box.isOpen()) {
		box.open({})
		let n = 0
		const timer = setInterval(() => {
			n++
			if (n >= 10) {
				clearInterval(timer)
				box.close()
			}
		}, 500)
	}
}
</script>


<template>
	<AppBox :title="t('title')">
		<Breadcrumbs :path="[
			[t('path.home'), '/'],
			[t('path.test-box'), '#']]" />

		<section class="testset">
			<h1>{{ t('generic') }}</h1>
			<article class="flexbox">
				<button class="normal" @click.prevent="open(t('close'), MessageBoxType.close, false, true)">
					{{ t('close') }}</button>
				<button class="normal" @click.prevent="open(t('ok'), MessageBoxType.ok, false, true)">
					{{ t('ok') }}</button>
				<button class="normal" @click.prevent="open(t('okCancel'), MessageBoxType.okCancel, false, true)">
					{{ t('okCancel') }}</button>
				<button class="normal" @click.prevent="open(t('yesNo'), MessageBoxType.yesNo, true, false)">
					{{ t('yesNo') }}</button>
				<button class="normal" @click.prevent="open(t('retryCancel'), MessageBoxType.retryCancel, true, false)">
					{{ t('retryCancel') }}</button>
			</article>
		</section>

		<section class="testset">
			<h1>{{ t('simple') }}</h1>
			<article class="flexbox">
				<button class="normal" @click.prevent="info">
					<i class="material-symbols-outlined">info</i>
					<span>{{ t('info') }}</span>
				</button>
				<button class="normal" @click.prevent="warning">
					<i class="material-symbols-outlined">warning</i>
					<span>{{ t('warning') }}</span>
				</button>
				<button class="normal" @click.prevent="error">
					<i class="material-symbols-outlined">error</i>
					<span>{{ t('error') }}</span>
				</button>
				<button class="normal" @click.prevent="question">
					<i class="material-symbols-outlined">help</i>
					<span>{{ t('question') }}</span>
				</button>
			</article>
		</section>

		<section class="testset">
			<h1>{{ t('wait') }}</h1>
			<article class="flexbox">
				<button class="normal" @click.prevent="wait">{{ t('wait') }}</button>
			</article>
		</section>

		<MessageBox ref="messageBox" />
		<WaitBox ref="waitBox" />
	</AppBox>
</template>
